﻿using System;
using System.Collections.Generic;

using Xamarin.Forms;
using SkiaSharp.Views.Forms;
using SkiaSharp;

namespace test5
{
	public partial class SecondPage : ContentPage
	{
		public SecondPage()
		{
			InitializeComponent();

			IList<int> list = new List<int>();
			for(int i = 0 ; i < 300 ; i++)
			{
				list.Add(0);
			}
			xListView.ItemsSource = list;

			ToolbarItem item = new ToolbarItem();
			item.Text = "PushPage";
			item.Clicked += (object sender, EventArgs e) => {
				Navigation.PushAsync(new SecondPage());
			};
			ToolbarItems.Add(item);
		}

		public void AddCloseButton()
		{
			ToolbarItem item = new ToolbarItem();
			item.Text = "Close";
			item.Clicked += (object sender, EventArgs e) => {
				Navigation.PopModalAsync();
			};
			ToolbarItems.Add(item);
		}
	}

	public class MyViewCell : ViewCell
	{
		public MyViewCell()
		{
			SKCanvasView skiaview = new SKCanvasView(){
				HorizontalOptions = LayoutOptions.FillAndExpand,
				HeightRequest = 200,
				BackgroundColor = Color.Transparent
			};
			skiaview.PaintSurface += (object sender, SKPaintSurfaceEventArgs e) => 
			{
				SKCanvas canvas = e.Surface.Canvas;
				canvas.Clear(SKColors.Transparent);

				using (SKPaint paint = new SKPaint())
				{
					paint.Color = SKColors.Red;
					paint.Style = SKPaintStyle.Stroke;
					paint.StrokeWidth = 1;
					paint.IsAntialias = true;
					if(new Random().Next()%2 == 0)
					{
						canvas.DrawLine(0, 0, e.Info.Width, e.Info.Height, paint);
					}
					else
					{
						canvas.DrawLine(0, e.Info.Height, e.Info.Width, 0, paint);
					}
					SKPath path = new SKPath();
					for(int i = 0 ; i < 10 ; i++)
					{
						path.MoveTo(i*60 + 0, 0);
						path.LineTo(i*60 + 50, 0);
						path.LineTo(i*60 + 25, 50);
						path.Close();
					}
					paint.Style = SKPaintStyle.Fill;
					paint.Color = SKColors.BlueViolet;

					paint.Shader = SKShader.CreateLinearGradient(
						new SKPoint(0, 0),
						new SKPoint(300, 0),
						new[] { SKColors.Red, SKColors.Blue },
						new float[] { 0, 1 },
						SKShaderTileMode.Clamp);
					
					canvas.DrawPath(path, paint);

					paint.TextSize = 50;
					paint.Style = SKPaintStyle.Fill;
					paint.Color = SKColors.Green;
					paint.TextAlign = SKTextAlign.Center;
					canvas.DrawText("SKIA TEXT", 100, 50, paint);
				}
			};

			AbsoluteLayout absolute = new AbsoluteLayout();
			absolute.Children.Add(skiaview);
			AbsoluteLayout.SetLayoutFlags(skiaview, AbsoluteLayoutFlags.All);
			AbsoluteLayout.SetLayoutBounds(skiaview, new Rectangle(0.5, 0.5, 1, 1));
			if(new Random().Next()%2 == 0)
				skiaview.IsVisible = false;

			Label label = new Label(){
				Text="dsflkdjsf sdklfdsjlfk sdjf ldskfjsd lkfsdjflksjfsdlk fsdl"
			};
			AbsoluteLayout.SetLayoutFlags(label, AbsoluteLayoutFlags.All);
			AbsoluteLayout.SetLayoutBounds(label, new Rectangle(0.5, 0.5, 1, 1));
			absolute.Children.Add(label);
			View = absolute;
		}
	}
}
